<?php
error_reporting(E_PARSE);
if($_GET['_SESSION'] != '' || $_POST['_SESSION'] != '' || $_COOKIE['_SESSION'] != '') { exit; }

#=====================================================================================
# Soholaunch(R) Site Management Tool
#
# Author:        Mike Morrison
# Homepage:      http://www.soholaunch.com
# Release Notes: http://wiki.soholaunch.com
#
# This Script: Simple example module to illustrate how to create a new
# module and keep it's look consistent with the rest of the product
#=====================================================================================

error_reporting(E_PARSE);
session_start();

# Include core files
include_once($_SESSION['docroot_path']."/sohoadmin/program/includes/product_gui.php");
include_once($_SESSION['docroot_path']."/sohoadmin/program/includes/smt_module.class.php");

# Define path to current language file
$langfile = "../../language/".$_SESSION['language'];

# Download language file
if ( $_GET['todo'] == "download_strings" ) {
   $local_name = basename($langfile);
   $fp = fopen($langfile, "r");
   $buff = fread($fp, filesize($langfile));
   Header("Content-Type: application/x-octet-stream");
   Header( "Content-Disposition: attachment; filename=\"$local_name\"");
   echo $buff; exit;
}


/*---------------------------------------------------------------------------------------------------------*
   ____
  / __/___ _ _  __ ___
 _\ \ / _ `/| |/ // -_)
/___/ \_,_/ |___/ \__/

# Save new translations (write to language file)
/*---------------------------------------------------------------------------------------------------------*/
if ( count($_POST['trans_string']) > 0 ) {

   # Read in current string list, strip trailing close tag
   $lang_strings = file_get_contents($langfile);
   $lang_strings = str_replace('?>', "", $lang_strings);
   $added = 0;

   if ( !$fp = fopen($langfile, "w") ) {
      $report[] = "Unable to open <b>".$langfile."</b> for writing!";

   } else { // Writeable

      # Build line additions and write to file
      foreach ( $_POST['trans_string'] as $stringkey=>$translation ) {
         if ( trim($translation) != "" ) {
            # Build lang file line
            $lang_strings .= "\$lang[\"".base64_decode($stringkey)."\"] = \"".$translation."\";\n";

            # Remove string from missing list
            unset($_SESSION['nolang'][$_SESSION['language']][$stringkey]);
            $added++;
         }
      }

      # ? > -- tack close php tag back on to end of string list
      $lang_strings .= '?>';

      fwrite($fp, $lang_strings);
      $report[] = "[".$added."] translations written to language file (".$_SESSION['language'].").";

      # Refresh lang array
      unset($_SESSION['lang']);
      include("../../language/".$_SESSION['language']);
      $_SESSION['lang'] = $lang;
   }

//   echo "<h1>\$lang_strings</h1>\n";
//   echo "<textarea style=\"width: 700px;height: 400px;\">".$lang_strings."</textarea>"; exit;
}

# switch_lang
if ( $_GET['switch_lang'] != "" ) {
   $_SESSION['language'] = $_GET['switch_lang'];
   unset($_SESSION['lang']);
   include("../../language/".$_GET['switch_lang']);
   $_SESSION['lang'] = $lang;
}


/*---------------------------------------------------------------------------------------------------------*
 _____           _  _
|_   _|___  ___ | || |__  __ _  _ _
  | | / _ \/ _ \| || '_ \/ _` || '_|
  |_| \___/\___/|_||_.__/\__,_||_|

# Build tool bar to be passed to module template as heading/module desciption text
/*---------------------------------------------------------------------------------------------------------*/
ob_start();

# popup-what_for
$popup = "";
$popup .= " \n";
$popup .= "<p>This is for people working to translate this product interface from the default English into a different language \n";
$popup .= "(i.e. French). If you've already made a copy of english.php (i.e. french.php) and translated all of the strings in \n";
$popup .= "it into the new language (i.e. French), you may have noticed that some text inside this interface are still in English.</p>\n";
$popup .= "<ol>\n";
$popup .= " <li>As you click around the product interface, this plugin runs behind the scenes and silently \"picks up\" text strings that \n";
$popup .= "  still appear in English because they are missing from your translated language file.</li>\n";
$popup .= " <li>At any point you can come here to this management module and it will prompt you to translate the missing text strings\n";
$popup .= "  it detected, then write the strings and your translation to your relevant language file.</li>\n";
$popup .= " <li>You get instant gratification. See a string that's stuck in English, come here to the management module,\n";
$popup .= "  translate it, then go back to where you first saw it and it'll be translated.</li>";
$popup .= "</ol>\n";
$popup .= "<h2>It'll get a lot of them...but not all</h2>\n";
$popup .= "<p>In order to fully understand what this plugin accomplishes, you've got to understand what's happening with those un-translatable text strings, and to do that\n";
$popup .= "you've got to understand how product interface handles translation, specifically via the <span class=\"code\">lang()</span> function...</p>\n";
$popup .= "<h2>How the product interface handles text translation...</h2>\n";
$popup .= "<p>If you've looked at any of the source files (pull a couple up now if not), \n";
$popup .= "you may have noticed that most all text strings are passed through a php function called \n";
$popup .= "<span class=\"code\">lang()</span> before being outputed to the browser.</p><br/>\n";
$popup .= "<p><i>Example of text being passed through lang() function in product source code...</i></p>\n";
$popup .= "<span class=\"code\">&lt;input type=\"button\" value=\"&lt;? echo lang(\"Main Menu\"); ?&gt;\"&gt;</span>\n";
//$popup .= "<h2>What the lang() function does<h2>\n";
//$popup .= " <ul>\n";
//$popup .= "  <li>Accepts an english text string</li>\n";
//$popup .= "  <li>If non-english language set as current in Webmaster > Global Settings, </li>\n";
$popup .= "<h2>There are three possible reasons why a particular piece of text still appears in English...</h2>";
$popup .= "<ol>\n";
$popup .= " <li>It's a graphic, not actual text</li>\n";
$popup .= " <li>Text is not being passed through lang() function in they php source code.</li>\n";
$popup .= " <li>Missing from string file - The text is being passed through the lang()\n";
$popup .= "  function, but there is not a translated entry for it in the language file for the currently-set language\n";
$popup .= "  (i.e. sohoadmin/language/french.php). <b>This is the case that this plugin is designed to help out with.</b></li>\n";
$popup .= "</ol>\n";
$other = array();
$other['onclose'] = "show_dropdowns();";
echo help_popup("popup-what_for", "What am I supposed to use this plugin for?", $popup, "left: 5%;top: 8%;width: 700px;height: 400px;overflow: scroll;", $other);

# popup-lang_dropdown
$popup = "";
$popup .= "<p>The languages available for you to choose in this drop-down box represent the translated string files currently\n";
$popup .= "found in your <span class=\"code\">public_html/sohoadmin/language/</span> folder.</p>\n";
$popup .= "<p>If the language your working on isn't listed here,\n";
$popup .= "log-in to your site via FTP and upload your translated string file (i.e. latin.php) to that sohoadmin/language folder,\n";
$popup .= "then come back here and it'll show up in the drop-down list.</p>\n";
echo help_popup("popup-lang_dropdown", "Why isn't my language listed as an option?", $popup, "left: 5%;top: 8%;", $other);

# Format languages vars for display
$current_lang = ucwords(str_replace(".php", "", $_SESSION['language']));
?>
   <table width="100%" cellpadding="3" cellspacing="0" border="0" class="lang_stats">
    <tr>
     <th width="20%">Current Language:</th>
     <td width="20%">
      <? echo $current_lang; ?> (<? echo $_SESSION['language']; ?>)
      <select name="switch_lang" onchange="document.location.href='<? echo $_SERVER['PHP_SELF'];?>?switch_lang='+this.value">
       <option value="">Change to...</option>

<?
# Build language drop-down list
$langDir = "../../language";
if ( $handle = opendir($langDir) ) {

   while ( false !== ($file = readdir($handle)) ) {
      if ( strlen($file) > 2 ) {
         # Disable current lang
         if ( $file == $_SESSION['language'] ) { $disabled = " disabled"; } else { $disabled = ""; }
         echo "<option value=\"".$file."\"".$disabled."".$selected.">".ucwords(str_replace(".php", "", $file))."</option>\n";
      }
   }

} else {
   echo "Could not open '".$langDir."'<br/>"; exit;
}
?>
      </select>
      <span class="help_link" onclick="toggleid('popup-lang_dropdown');hide_dropdowns();">[?]</span>
     </td>

     <!---Download language file-->
     <td width="20%"><a href="<? echo $_SERVER['PHP_SELF']; ?>?todo=download_strings" class="bold sav noline">[&darr;] Download my <? echo $_SESSION['language']; ?></a></td>

     <td>
      <span class="help_link" onclick="toggleid('popup-what_for');hide_dropdowns();">[?] What does this plugin do?</span>
     </td>

     <!---Report missing-->
<!---      <td style="padding-left: 20px;"><span class="help_link">[?] Report missing strings</span></td> -->

    </tr>
   </table>
<?
$lang_toolbar = ob_get_contents();
ob_end_clean();


/*---------------------------------------------------------------------------------------------------------*
 __  __          _        _        ___   _            _
|  \/  | ___  __| | _  _ | | ___  |   \ (_) ___ _ __ | | __ _  _  _
| |\/| |/ _ \/ _` || || || |/ -_) | |) || |(_-<| '_ \| |/ _` || || |
|_|  |_|\___/\__,_| \_,_||_|\___| |___/ |_|/__/| .__/|_|\__,_| \_, |
                                               |_|             |__/
/*---------------------------------------------------------------------------------------------------------*/
# clear_nolang
if ( $_GET['todo'] == "clear_nolang" ) {
   unset($_SESSION['nolang'][$_SESSION['language']]);
   $report[] = "Un-translated string log cleared for this language.";
}

# num_at_a_time
if ( $_POST['num_at_a_time'] != "" ) {
   $_SESSION['translate']['num_at_a_time'] = $_POST['num_at_a_time'];
}
# DEFAULT: num_at_a_time
if ( $_SESSION['translate']['num_at_a_time'] == "" ) {
   $_SESSION['translate']['num_at_a_time'] = 3;
}

# So you can write straight HTML without having to build every line into a container var (i.e. $disHTML .= "another line of html")
ob_start();

?>

<style>
p.missing_string {
   width: 250px;
   font-family: Courier New, courier, mono;
   font-size: 11px;
   border: 1px solid #ccc;
   background-color: #efefef;
}

textarea.translated {
   width: 250px;
   height: 50px;
}

table.lang_stats th {
   /*vertical-align: top;*/
   text-align: left;
   background-color: #efefef;
}

table.toolbar_parent td {
   vertical-align: top;
}

.code {
   font-family: Courier New, Courier, mono;
   background: #ccc;
}
</style>

<table cellpadding="3" cellspacing="0" border="0">
 <tr>
  <td>
   [<b><? echo count($_SESSION['nolang'][$_SESSION['language']]); ?></b>] un-translated strings found.
   (<a href="<? echo $_SERVER['PHP_SELF']; ?>?todo=clear_nolang">clear</a>)
  </td>
  <td width="12%">Translate:</td>
  <td>
   <form name="atatime_form" method="post" action="<? echo $_SERVER['PHP_SELF']; ?>" style="margin: 0;">
    <select id="num_at_a_time" name="num_at_a_time" onchange="document.atatime_form.submit();">
     <option value="3">3 at a time</option>
     <option value="10">10 at a time</option>
     <option value="25">25 at a time</option>
     <option value="50">50 at a time</option>
     <option value="all">All at once</option>
    </select>
   </form>

   <script type="text/javascript">
   $('num_at_a_time').value = '<? echo $_SESSION['translate']['num_at_a_time']; ?>';
   </script>
  </td>
 </tr>
</table>


<div id="missing_string_list" style="display: block;">
<?
//foreach ( $_SESSION['nolang'] as $string=>$value ) {
//   echo " <p class=\"missing_string\">".base64_decode($string)."</p>";
//}

//echo testArray($_SESSION['nolang'][$_SESSION['language']]);

# Translation form
echo "<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."\">\n";
echo "<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" class=\"marginfix\">\n";
echo " <tr>\n";
echo "  <td>&nbsp;</td>\n";
echo "  <td><h2>".lang("English string")."...</h2></td>\n";
echo "  <td>&nbsp;</td>\n";
echo "  <td><h2>".$current_lang." ".lang("translation")."...</h2></td>\n";
echo " </tr>\n";

$num = 1;
foreach ( $_SESSION['nolang'][$_SESSION['language']] as $string_key=>$value ) {
   $idname = "row_".$num;
   echo " <tr id=\"".$idname."\" onmouseover=\"setClass(this.id, 'bg_yellow');\" onmouseout=\"setClass(this.id, '');\">\n";

   echo "  <td valign=\"top\"><span style=\"font-size: 14px;font-weight: bold;\">".$num.".</span></td>\n";

   # Original
   echo "  <td valign=\"top\">\n";
   echo "   <p class=\"missing_string\" style=\"\">".base64_decode($string_key)."</p>\n";
   echo "  </td>\n";

   # -->
   echo "  <td><span style=\"font-size: 14px;font-weight: bold;\">&rarr;</span></td>\n";

   # Translated...
   echo "  <td valign=\"top\">\n";
   echo "   <p><textarea name=\"trans_string[".$string_key."]\" class=\"translated\"></textarea></p>\n";
   echo "  </td>\n";

   echo " </tr>\n";

   if ( $num == $_SESSION['translate']['num_at_a_time'] ) { break; }

   $num++;
}

echo " <tr>\n";
echo "  <td colspan=\"4\" align=\"right\">\n";
echo "   <p><b>Note:</b> Save button will append new translated strings to bottom of your ".$_SESSION['language']."</p>\n";
echo "   <input type=\"submit\" value=\"Add to string file &gt;&gt;\">\n";
echo "  </td>\n";
echo " </tr>\n";

echo "</table>\n";
echo "</form>\n";
echo "</div>\n";

# Grab module html into container var
$module_html = ob_get_contents();
ob_end_clean();

$module = new smt_module($module_html);
$module->meta_title = "Log un-translated strings";
$module->add_breadcrumb_link("Log un-translated strings", "plugins/log_untranslated_strings/management_module.php");
$module->icon_img = "skins/".$_SESSION['skin']."/icons/full_size/plugins-enabled.gif";
$module->heading_text = "Find and translate strings missing from launguage file.";
$module->description_text = $lang_toolbar;
$module->good_to_go();
?>